# PAYONE Payment Plugin for Shopware 5

![CI Status](https://img.shields.io/github/workflow/status/PAYONE-GmbH/shopware-5/CI)
![License](https://img.shields.io/github/license/PAYONE-GmbH/shopware-5)
![Latest release version (semver)](https://img.shields.io/github/v/release/PAYONE-GmbH/shopware-5)

The official extension for [Shopware 5](https://www.payone.com/DE-de/payment-loesungen/online-shops/shopware) to enable payment for your
website via PAYONE service.

## Installation
### Prerequisites
You should have your PAYONE API credentials. If you don't have
them, [contact PAYONE](https://payone.com).

### Install
From PAYONE's official docs site, you can install the plugin in two ways:
- [directly in Shopware](https://docs.payone.com/display/public/INT/Integration+Guide+Shopware+5#expand-InstallationdirectlyinShopwareAdmin)
- directly downloading from GitHub

## Features
- Certified by [shoplupe](https://shoplupe.com/) for its usability
- Very wide range of functions, simple and comprehensible supported by detailed online help
- Integrates via AJAX into the existing Shopware Shop; checkout without redirection to third-party websites
- Credit assessments with dynamic payment option control in the checkout section depending on the consumer's credit rating
- Export function of the configuration in XML format to get easier support
- Optional multi-partial capture for partial deliveries
- Supports simplified PCI DSS conformity in accordance with SAQ A
- Find all currently supported payment methods on [the dedicated docs' page on our site](https://docs.payone.com/display/public/INT/Shopware+5+Plugin)

## Documentation
You can check [the documentation on our website here](https://docs.payone.com/display/public/INT/Shopware+5+Plugin).

## Contact
PAYONE GmbH<br>
Fraunhoferstraße 2-4<br>
24118 Kiel, Germany<br>
[payone.com](https://www.payone.com/DE-de)<br>
Phone +49 431 25968-400<br>
<p>
sales@payone.com<br>
tech.support@payone.com<br>
